function  comprUP
Tmax=120;
a1=0.5; a2=0.5; %    
acc=0.0003;
options = odeset('RelTol', 3e-5); % 
c0=[0 0 0 1 0.365 0.365 -0.095];% 
c0(4)=sqrt(1-c0(5)^2-c0(6)^2-c0(7)^2); %l0=sqrt(1-l1^2-l2^2-l3^2) -  
%cT=[0 0 0 1 0 0 0]; % 
I1=100;     I2=180;     I3=150; %  
r1=1;       r2=1;       r3=1;   % 
umax=0.45; %      
I32=I3-I2; I13=I1-I3; I21=I2-I1;
clc;
disp('   " "');
load region T G K;
n=length(T);
figure;
plot(0,0,'.');grid on;hold on;
set(gcf,'Color',[1 1 1],'Units','centimeters',...
        'Position',[1 1 15 15]); 
plot(T,G,'b.');grid on;hold on;
tic;
pareto.t=zeros(n,1);
pareto.g=zeros(n,1);
pareto.k=zeros(n,6);
l=0;
disp(' -...');
% 
for ii=1:n,
    fl=1;
    for jj=1:n,
        if T(jj)<T(ii),
            if G(jj)<G(ii),
                fl=0;
                break;
            end
        end
    end
    if fl,
       l=l+1;
       pareto.t(l)=T(ii);
       pareto.g(l)=G(ii);
       pareto.k(l,1:6)=K(ii,1:6);
    end
end
pareto.t=pareto.t(1:l);
pareto.g=pareto.g(1:l);
pareto.k=pareto.k(1:l,1:6);
plot(pareto.t,pareto.g,'k.');hold on;
% !!!

disp('  ...');
iminG=1;iminT=1;
for ii=1:l,
    if pareto.t(ii)<pareto.t(iminT),iminT=ii; end
    if pareto.g(ii)<pareto.g(iminG),iminG=ii; end
end
ipT.t=pareto.t(iminT);
ipT.g=pareto.g(iminT);
ipT.k(1:6)=pareto.k(iminT,1:6);
ipG.t=pareto.t(iminG);
ipG.g=pareto.g(iminG);
ipG.k(1:6)=pareto.k(iminG,1:6);
plot(ipT.t,ipG.g,'r*');hold on;

% c
disp('  ...');
iminR=1;
Rmin=salukvadze(pareto.t(1),pareto.g(1),ipT.t,ipG.g);
for ii=2:l,
    R=salukvadze(pareto.t(ii),pareto.g(ii),ipT.t,ipG.g);
    if R<Rmin,
        iminR=ii; 
        Rmin=salukvadze(pareto.t(iminR),pareto.g(iminR),ipT.t,ipG.g);
    end
end
kp.t=pareto.t(iminR);
kp.g=pareto.g(iminR);
kp.k(1:6)=pareto.k(iminR,1:6);
plot(kp.t,kp.g,'ro');hold on;
timeC=toc;
% 
save region pareto ipT ipG kp timeC -append;

disp(' ...');
[tt,yy]=ode45(@model,[0 kp.t],c0,options,kp.k);
plotF(tt,yy,kp.k);

%[t,y]=ode45(@model,[0 Tmax],c0,options,ipG.k);
%plotF(t,y,ipG.k);

%[t,y]=ode45(@model,[0 Tmax],c0,options,ipT.k);
%plotF(t,y,ipT.k);
disp('  :');
disp(timeC);
disp('!');

    function dydt = model(t,y,kk) 
        u = kpzU(y,kk);
        dydt = [ (u(1)-I32*y(2)*y(3))/I1
                 (u(2)-I13*y(1)*y(3))/I2
                 (u(3)-I21*y(1)*y(2))/I3
                 (-y(5)*y(1)-y(6)*y(2)-y(7)*y(3))/2
                 (y(4)*y(1)+y(6)*y(3)-y(7)*y(2))/2
                 (y(4)*y(2)+y(7)*y(1)-y(5)*y(3))/2
                 (y(4)*y(3)+y(5)*y(2)-y(6)*y(1))/2 ];
    end

    function uu = kpzU(y,kk)
        u1=-kk(1)*y(1)-kk(2)*y(4)*y(5);
        u2=-kk(3)*y(2)-kk(4)*y(4)*y(6);
        u3=-kk(5)*y(3)-kk(6)*y(4)*y(7);
        if abs(u1)>umax, u1=umax*sign(u1); end
        if abs(u2)>umax, u2=umax*sign(u2); end
        if abs(u3)>umax, u3=umax*sign(u3); end
        %if abs(u1)<umin, u1=0; end;
        %if abs(u2)<umin, u2=0; end;
        %if abs(u3)<umin, u3=0; end;
        uu = [ u1
               u2
               u3 ];
    end

    function upr = fU(t,y,kk)
        imax=length(t);
        fu1 = zeros (1,imax);
        fu2 = zeros (1,imax);
        fu3 = zeros (1,imax);
        for i=1:imax,
            u = kpzU(y(i,:),kk);
            fu1(i) = u(1);
            fu2(i) = u(2);
            fu3(i) = u(3);
        end;
        upr = [ fu1(:) fu2(:) fu3(:) ];
    end

    function plotF(t,y,kk)
        figure;
        set(gcf,'Color',[1 1 1]); 
        % 
        subplot(3,1,1);
        plot(t,y(:,1));grid on;
        title('w1(t)');
        set(gca,'XLim',[0 max(t)]);

        subplot(3,1,2);
        plot(t,y(:,2));grid on;
        title('w2(t)');
        set(gca,'XLim',[0 max(t)]);

        subplot(3,1,3);
        plot(t,y(:,3));grid on;
        title('w3(t)');
        set(gca,'XLim',[0 max(t)]); 
        
        figure;
        set(gcf,'Color',[1 1 1]); 

        subplot(4,1,1);
        plot(t,y(:,1+4));grid on;
        title('l1(t)');
        set(gca,'XLim',[0 max(t)]);

        subplot(4,1,2);
        plot(t,y(:,2+4));grid on;
        title('l2(t)');
        set(gca,'XLim',[0 max(t)]);

        subplot(4,1,3);
        plot(t,y(:,3+4));grid on;
        title('l3(t)');
        set(gca,'XLim',[0 max(t)]);

        subplot(4,1,4);
        plot(t,y(:,4));grid on;
        title('l0(t)');
        set(gca,'XLim',[0 max(t)]);

        %disp(y(length(t),:));
        
        uu = fU(t,y,kk);
        uu1=uu(:,1); uu2=uu(:,2); uu3=uu(:,3);

        figure;
        set(gcf,'Color',[1 1 1]); 
        subplot(3,1,1);
        plot(t,uu1(:));grid on;
        title('u1(t)');
        set(gca,'XLim',[0 max(t)]);
        
        subplot(3,1,2);
        plot(t,uu2(:));grid on;
        title('u2(t)');
        set(gca,'XLim',[0 max(t)]);
        
        subplot(3,1,3);
        plot(t,uu3(:));grid on;
        title('u3(t)');
        set(gca,'XLim',[0 max(t)]);
    end 

    function TG = criterions(t,y,k)
        imax=length(t);
        intube=false;
        for i=1:imax,
            e = [ y(i,1)
                  y(i,2)
                  y(i,3)
                  2*y(i,4)*y(i,5)
                  2*y(i,4)*y(i,6)
                  2*y(i,4)*y(i,7) ];
            emax=max(e);
            if and(emax<=acc,intube==false), intube=true; iTp=i; end
            if emax>acc, intube=false; end
        end %for
        if intube==true,
            up=fU(t,y,k);
            TG = [ t(iTp) 
                   trapz(t(1:iTp),abs(up(1:iTp,1))/r1+abs(up(1:iTp,2))/r2+abs(up(1:iTp,3))/r3) ];
        else
            TG = [ -1 -1 ];
        end %if
    end

    function rr = salukvadze(st,sg,stI,sgI)
        rr = a1*((st-stI)/stI)^2 + a2*((sg-sgI)/sgI)^2;
    end

end